%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%global srcname odoc

Name:           ocaml-%{srcname}
Version:        2.4.4
Release:        %mkrel 1
Summary:        Documentation compiler for OCaml and Reason

Group:          Development/OCaml
License:        ISC
URL:            https://github.com/ocaml/odoc
Source0:        %{url}/releases/download/%{version}/odoc-%{version}.tbz

BuildRequires:  jq-devel
BuildRequires:  ocaml >= 4.02.0
BuildRequires:  ocaml-astring-devel
BuildRequires:  ocaml-bisect-ppx-devel > 2.5.0
BuildRequires:  ocaml-bos-devel
BuildRequires:  ocaml-camlp-streams-devel
BuildRequires:  ocaml-cmdliner-devel >= 1.0.0
BuildRequires:  ocaml-cppo >= 1.1.0
BuildRequires:  ocaml-crunch-devel > 2.0.0
BuildRequires:  ocaml-dune >= 3.7.0
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-fmt-devel
BuildRequires:  ocaml-fpath-devel
BuildRequires:  ocaml-mdx-devel
BuildRequires:  ocaml-ppx_expect-devel
BuildRequires:  ocaml-result-devel
BuildRequires:  ocaml-sexplib0-devel
BuildRequires:  ocaml-tyxml-devel >= 4.4.0
BuildRequires:  ocaml-yojson-devel >= 1.6.0

Requires:       ocaml-odoc-parser%{?_isa} = %{version}-%{release}

%description
This package contains odoc, a documentation generator for OCaml.  It
reads doc comments, delimited with `(** ... *)`, and outputs HTML.  Text
inside doc comments is marked up in ocamldoc syntax.

Odoc's main advantage over ocamldoc is an accurate cross-referencer,
which handles the complexity of the OCaml module system.  Odoc also
offers a good opportunity to improve HTML output compared to ocamldoc,
but this is very much a work in progress.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-parser-devel%{?_isa} = %{version}-%{release}
Requires:       ocaml-astring-devel%{?_isa}
Requires:       ocaml-fmt-devel%{?_isa}
Requires:       ocaml-fpath-devel%{?_isa}
Requires:       ocaml-result-devel%{?_isa}
Requires:       ocaml-tyxml-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%package        parser
License:        ISC
Summary:        Parser for OCaml documentation comments

%description    parser
Odoc-parser is a parser for odoc markup, which is an extension of the
original markup language parsed by ocamldoc.

OCaml code can contain specially formatted comments that are used to
document the interfaces of modules.  These comments are delimited by
`(**` and `*)`.  This parser is intended to be used to parse the
contents of these comments.

%package        parser-devel
Summary:        Development files for %{name}-parser
Requires:       %{name}-parser%{?_isa} = %{version}-%{release}
Requires:       ocaml-astring-devel%{?_isa}
Requires:       ocaml-camlp-streams-devel%{?_isa}
Requires:       ocaml-result-devel%{?_isa}

%description    parser-devel
The %{name}-parser-devel package contains libraries and signature
files for developing applications that use %{name}-parser.

%package        doc
Summary:        Documentation for %{name}
BuildArch:      noarch

%description    doc
Documentation for %{name}.

%prep
%autosetup -n %{srcname}-%{version} -p1

%build
%dune_build @install @doc

%install
%dune_install -s

# Install the man page
mkdir -p %{buildroot}%{_mandir}/man1
_build/install/default/bin/odoc --help groff > %{buildroot}%{_mandir}/man1/odoc.1

# We don't want the benchmark package
rm -fr %{buildroot}%{ocamldir}/odoc-bench

%check
%dune_check

%files -f .ofiles-odoc
%doc CHANGES.md README.md
%license LICENSE.md
%{_mandir}/man1/odoc.1*

%files devel -f .ofiles-odoc-devel

%files parser -f .ofiles-odoc-parser
%license LICENSE

%files parser-devel -f .ofiles-odoc-parser-devel

%files doc
%doc _build/default/_doc/_html/*
%license LICENSE


%changelog
* Thu Jun 19 2025 daviddavid <daviddavid> 2.4.4-1.mga10
+ Revision: 2192825
- new version: 2.4.4
- ocaml-odoc-parser is now merged here

* Thu Oct 20 2022 pterjan <pterjan> 2.1.1-1.mga9
+ Revision: 1898040
- Cleanup sha1.lst
+ neoclust <neoclust>
- New version 2.1.1
- Rebuild against new ocaml-base

* Fri May 20 2022 pterjan <pterjan> 2.1.0-1.mga9
+ Revision: 1859588
- Update to 2.1.0
- Rebuild for OCaml 4.14

* Wed May 18 2022 pterjan <pterjan> 1.5.3-2.mga9
+ Revision: 1858700
- Rebuild for several updated ocaml dependencies

* Fri Oct 15 2021 tv <tv> 1.5.3-1.mga9
+ Revision: 1751641
- 1.5.3

* Sun Mar 28 2021 tv <tv> 1.5.2-1.mga9
+ Revision: 1711253
- imported package ocaml-odoc


* Mon Mar  1 2021 Richard W.M. Jones <rjones@redhat.com> - 1.5.2-4
- OCaml 4.12.0 build

* Tue Feb  2 2021 Richard W.M. Jones <rjones@redhat.com> - 1.5.2-3
- Bump and rebuild for updated ocaml-camomile dep (RHBZ#1923853).

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Dec  2 2020 Jerry James <loganjerry@gmail.com> - 1.5.2-1
- Version 1.5.2

* Fri Oct 23 2020 Jerry James <loganjerry@gmail.com> - 1.5.1-5
- Rebuild for ocaml-markup 1.0.0

* Fri Sep 25 2020 Jerry James <loganjerry@gmail.com> - 1.5.1-4
- Rebuild for ocaml-fpath 0.7.3

* Tue Sep 01 2020 Richard W.M. Jones <rjones@redhat.com> - 1.5.1-3
- OCaml 4.11.1 rebuild

* Fri Aug 21 2020 Richard W.M. Jones <rjones@redhat.com> - 1.5.1-2
- OCaml 4.11.0 rebuild

* Wed Aug  5 2020 Jerry James <loganjerry@gmail.com> - 1.5.1-1
- Version 1.5.1
- Drop upstreamed odoc-1.5.0-ocaml411.patch

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.0-7
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue May 05 2020 Richard W.M. Jones <rjones@redhat.com> - 1.5.0-5
- OCaml 4.11.0+dev2-2020-04-22 rebuild

* Wed Apr 22 2020 Richard W.M. Jones <rjones@redhat.com> - 1.5.0-4
- OCaml 4.11.0 pre-release attempt 2

* Sat Apr 04 2020 Richard W.M. Jones <rjones@redhat.com> - 1.5.0-3
- Update all OCaml dependencies for RPM 4.16.

* Wed Feb 26 2020 Richard W.M. Jones <rjones@redhat.com> - 1.5.0-2
- OCaml 4.10.0 final.

* Fri Feb  7 2020 Jerry James <loganjerry@gmail.com> - 1.5.0-1
- Version 1.5.0
- Drop all patches

* Sat Feb  1 2020 Jerry James <loganjerry@gmail.com> - 1.4.2-3
- Add 3 patches for OCaml 4.10 compatibility

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jan 16 2020 Jerry James <loganjerry@gmail.com> - 1.4.2-2
- Remove some BRs needed only for transitive dependencies
- Add ocaml-astring-devel and ocaml-fpath-devel Rs to -devel
- Build in parallel

* Fri Jan 10 2020 Jerry James <loganjerry@gmail.com> - 1.4.2-1
- Initial RPM
